use swc_common::{SourceMap, sync::Lrc};
use swc_ecma_ast::Module;
use swc_ecma_codegen::{Config, Emitter, text_writer::JsWriter};

pub struct JsEmitter;

impl JsEmitter {
    pub fn new() -> Self {
        Self
    }
    pub fn emit(&self, ast: Module) -> (String, Lrc<SourceMap>) {
        let sm = Lrc::new(SourceMap::default());
        let mut buf = vec![];
        let mut emitter = Emitter {
            cfg: Config::default(),
            cm: sm.clone(),
            comments: None,
            wr: JsWriter::new(sm.clone(), "\n", &mut buf, None),
        };

        emitter.emit_module(&ast).unwrap();
        (String::from_utf8(buf).unwrap(), sm)
    }
}
